ScoreMode (Lucene 10.5.1 core API)
Description: declaration: package: org.apache.lucene.search, enum: ScoreMode

Package org.apache.lucene.search

# Enum Class ScoreMode

java.lang.Object
java.lang.Enum<ScoreMode>
org.apache.lucene.search.ScoreMode

All Implemented Interfaces:
  `Serializable`, `Comparable<ScoreMode>`, `Constable`

public enum ScoreMode extends Enum<ScoreMode>
Different modes of search.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `COMPLETE`
  Produced scorers will allow visiting all matches and get their score.
  `COMPLETE_NO_SCORES`
  Produced scorers will allow visiting all matches but scores won't be available.
  `TOP_DOCS`
  ScoreMode for top field collectors that can provide their own iterators, to optionally allow to skip for non-competitive docs
  `TOP_DOCS_WITH_SCORES`
  ScoreMode for top field collectors that can provide their own iterators, to optionally allow to skip for non-competitive docs.
  `TOP_SCORES`
  Produced scorers will optionally allow skipping over non-competitive hits using the `Scorable.setMinCompetitiveScore(float)` API.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `isExhaustive()`
  Returns `true` if for this `ScoreMode` it is necessary to process all documents, or `false` if is enough to go through top documents only.
  `boolean`
  `needsScores()`
  Whether this `ScoreMode` needs to compute scores.
  `static ScoreMode`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static ScoreMode[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### COMPLETE

    public static final ScoreMode COMPLETE
    Produced scorers will allow visiting all matches and get their score.

  - ### COMPLETE_NO_SCORES

    public static final ScoreMode COMPLETE_NO_SCORES
    Produced scorers will allow visiting all matches but scores won't be available.

  - ### TOP_SCORES

    public static final ScoreMode TOP_SCORES
    Produced scorers will optionally allow skipping over non-competitive hits using the `Scorable.setMinCompetitiveScore(float)` API.

  - ### TOP_DOCS

    public static final ScoreMode TOP_DOCS
    ScoreMode for top field collectors that can provide their own iterators, to optionally allow to skip for non-competitive docs

  - ### TOP_DOCS_WITH_SCORES

    public static final ScoreMode TOP_DOCS_WITH_SCORES
    ScoreMode for top field collectors that can provide their own iterators, to optionally allow to skip for non-competitive docs. This mode is used when there is a secondary sort by _score.

- ## Method Details

  - ### values

    public static ScoreMode[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static ScoreMode valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### needsScores

    public boolean needsScores()
    Whether this `ScoreMode` needs to compute scores.

  - ### isExhaustive

    public boolean isExhaustive()
    Returns `true` if for this `ScoreMode` it is necessary to process all documents, or `false` if is enough to go through top documents only.